Attribute VB_Name = "MRunOnce"
' *************************************************************
'  Copyright (C)1998, Karl E. Peterson
'  http://www.mvps.org/vb/
' *************************************************************
'  Author grants royalty-free rights to use this code within
'  compiled applications. Selling or otherwise distributing
'  this source code is not allowed without author's express
'  permission.
' *************************************************************
Option Explicit
'
' Win32 Registry functions
'
Private Declare Function RegCreateKeyEx Lib "advapi32.dll" Alias "RegCreateKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal Reserved As Long, ByVal lpClass As String, ByVal dwOptions As Long, ByVal samDesired As Long, lpSecurityAttributes As Any, phkResult As Long, lpdwDisposition As Long) As Long
Private Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpData As Any, ByVal cbData As Long) As Long         ' Note that if you declare the lpData parameter as String, you must pass it By Value.
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
'
' Constants for Windows 32-bit Registry API
'
'Private Const HKEY_CLASSES_ROOT = &H80000000
Private Const HKEY_CURRENT_USER = &H80000001
Private Const HKEY_LOCAL_MACHINE = &H80000002
'Private Const HKEY_USERS = &H80000003
'Private Const HKEY_PERFORMANCE_DATA = &H80000004
'Private Const HKEY_CURRENT_CONFIG = &H80000005
'Private Const HKEY_DYN_DATA = &H80000006
'
' Reg result codes
'
'Private Const REG_CREATED_NEW_KEY = &H1                      ' New Registry Key created
'Private Const REG_OPENED_EXISTING_KEY = &H2                      ' Existing Key opened
'
' Reg Create Type Values...
'
'Private Const REG_OPTION_RESERVED = 0           ' Parameter is reserved
Private Const REG_OPTION_NON_VOLATILE = 0       ' Key is preserved when system is rebooted
'Private Const REG_OPTION_VOLATILE = 1           ' Key is not preserved when system is rebooted
'Private Const REG_OPTION_CREATE_LINK = 2        ' Created key is a symbolic link
'Private Const REG_OPTION_BACKUP_RESTORE = 4     ' open for backup or restore
'
' Reg Key Security Options
'
'Private Const DELETE = &H10000
'Private Const READ_CONTROL = &H20000
'Private Const WRITE_DAC = &H40000
'Private Const WRITE_OWNER = &H80000
Private Const SYNCHRONIZE = &H100000
'Private Const STANDARD_RIGHTS_READ = (READ_CONTROL)
'Private Const STANDARD_RIGHTS_WRITE = (READ_CONTROL)
'Private Const STANDARD_RIGHTS_EXECUTE = (READ_CONTROL)
'Private Const STANDARD_RIGHTS_REQUIRED = &HF0000
Private Const STANDARD_RIGHTS_ALL = &H1F0000
'Private Const SPECIFIC_RIGHTS_ALL = &HFFFF
Private Const KEY_QUERY_VALUE = &H1
Private Const KEY_SET_VALUE = &H2
Private Const KEY_CREATE_SUB_KEY = &H4
Private Const KEY_ENUMERATE_SUB_KEYS = &H8
Private Const KEY_NOTIFY = &H10
Private Const KEY_CREATE_LINK = &H20
'Private Const KEY_READ = ((STANDARD_RIGHTS_READ Or KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY) And (Not SYNCHRONIZE))
'Private Const KEY_WRITE = ((STANDARD_RIGHTS_WRITE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY) And (Not SYNCHRONIZE))
Private Const KEY_ALL_ACCESS = ((STANDARD_RIGHTS_ALL Or KEY_QUERY_VALUE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY Or KEY_CREATE_LINK) And (Not SYNCHRONIZE))
'Private Const KEY_EXECUTE = ((KEY_READ) And (Not SYNCHRONIZE))

Private Const ERROR_SUCCESS = 0&
'Private Const ERROR_MORE_DATA = 234

Private Const REG_SZ = 1                         ' Unicode nul terminated string

Public Function RunNextBoot( _
   ByVal AppName As String, ByVal CmdLine As String, _
   Optional ThisUserOnly As Boolean = False, _
   Optional RunEveryBoot As Boolean = False) As Boolean
   
   Dim SubKey As String
   Dim TopKey As Long
   Dim nRet As Long
   Dim hKey As Long
   Dim nResult As Long
   
   ' Assign subkey string appropriately.
   If RunEveryBoot Then
      SubKey = "SOFTWARE\Microsoft\Windows\CurrentVersion\Run"
   Else
      SubKey = "SOFTWARE\Microsoft\Windows\CurrentVersion\RunOnce"
   End If
   
   ' Select appropriate top-level key.
   If ThisUserOnly Then
      TopKey = HKEY_CURRENT_USER
   Else
      TopKey = HKEY_LOCAL_MACHINE
   End If
   
   ' Open (or create and open) key
   nRet = RegCreateKeyEx(TopKey, SubKey, 0&, vbNullString, _
      REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, ByVal 0&, _
      hKey, nResult)
   If nRet = ERROR_SUCCESS Then
      ' Write new value to registry
      nRet = RegSetValueEx(hKey, AppName, 0&, REG_SZ, _
         ByVal CmdLine, Len(CmdLine))
      Call RegCloseKey(hKey)
   End If
   RunNextBoot = (nRet = ERROR_SUCCESS)
End Function
